// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/sensor.hpp"



sensor::sensor() :
    sensor_low_old(false),
    sensor_high_old(false),
    pwdata_old(0UL),
    pwrite_old(false),
    penable_old(false),
    psel_old(false),
    paddr_old(0UL),
    presetn_old(false),
    pclk_old(false),
    hif_a2t_data(
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr),
    prdata_var_1(0UL),
    process_in_queue(false),
    flag_pos_pclk(false)
{
}


sensor::~sensor()
{}


void sensor::process()
{
    prdata_var_1 = *hif_a2t_data.prdata;
    if (*hif_a2t_data.penable)
    {
        prdata_var_1 = *hif_a2t_data.sensor_high ? prdata_var_1 | uint32_t(1UL)
             : prdata_var_1 & uint32_t(4294967294UL);
        prdata_var_1 = prdata_var_1 & 4294967041UL;
        prdata_var_1 = *hif_a2t_data.sensor_low ? prdata_var_1 | uint32_t(256UL
            ) : prdata_var_1 & uint32_t(4294967039UL);
        prdata_var_1 = prdata_var_1 & 4294902271UL;
        prdata_var_1 = prdata_var_1 & 65535UL;
        *hif_a2t_data.pready = true;
    }
    else
    {
        prdata_var_1 = 0UL;
        *hif_a2t_data.pready = false;
    }
    *hif_a2t_data.prdata = prdata_var_1;
}


void sensor::update_input_queue( bool synch_phase )
{
    process_in_queue = false;
    if (*hif_a2t_data.pclk != pclk_old)
    {
        pclk_old = *hif_a2t_data.pclk;
        if (*hif_a2t_data.pclk == true)
        {
            flag_pos_pclk = true;
        }
        else
        {
            flag_pos_pclk = false;
        }
        process_in_queue = true;
    }
    else
    {
        flag_pos_pclk = false;
    }
    presetn_old = *hif_a2t_data.presetn;
    paddr_old = *hif_a2t_data.paddr;
    psel_old = *hif_a2t_data.psel;
    penable_old = *hif_a2t_data.penable;
    pwrite_old = *hif_a2t_data.pwrite;
    pwdata_old = *hif_a2t_data.pwdata;
    sensor_high_old = *hif_a2t_data.sensor_high;
    sensor_low_old = *hif_a2t_data.sensor_low;
}


void sensor::update_event_queue()
{
    process_in_queue = false;
    update_input_queue( false );
}


void sensor::flag_elaboration()
{
    if (flag_pos_pclk)
    {
        process();
    }
}


void sensor::start_of_simulation()
{
    process();
}


void sensor::initialize()
{
    start_of_simulation();
}




